
import scala.concurrent._
import scala.concurrent.duration._
import ExecutionContext.Implicits.global
import scala.language.postfixOps 


val EVIL_urban = SEQ(STAR(STAR(CHAR('a'))), CHAR('b'))

lazy val f = Future {
  println("1")
  assert(ders(List.fill(5)('a'), EVIL_urban) == SEQ(SEQ(STAR(CHAR('a')),STAR(STAR(CHAR('a')))),CHAR('b')))
  println("2")
  assert(ders(List('b'), EVIL_urban) == ONE)
  println("3")
  assert(ders(List('b','b'), EVIL_urban) == ZERO)
  println("4")
  assert(matcher(EVIL_urban, "a" * 5 ++ "b") == true)
  println("5")
  assert(matcher(EVIL_urban, "b") == true)
  println("6") 
  assert(matcher(EVIL_urban, "bb") == false)
  println("7")
  assert(matcher("abc", "abc") == true)
  println("8")
  assert(matcher(("ab" | "a") ~ (ONE | "bc"), "abc") == true)
  println("9")
  assert(matcher(ONE, "") == true)
  println("10")
  assert(matcher(ZERO, "") == false)
  println("11")
  assert(matcher(ONE | CHAR('a'), "") == true)
  println("12")
  assert(matcher(ONE | CHAR('a'), "a") == true)
}

Await.result(f, 90 second)
